package oose.class_diagram;
import java.util.Arrays;
import java.util.Collection;

public class CaseAndPower extends PackagedProducts {
	private boolean serverClass;
	private boolean towerForm;
	private Collection<Product> powerSource;
	private Product systemCase;
	
	public CaseAndPower(boolean serverClass, boolean towerForm, Product systemCase, Product... powerSources) {
		if (powerSources.length < 1) throw new RuntimeException("Must contain at least one power source.");
		if (powerSources.length > 2) throw new RuntimeException("Must contain at most two power sources.");
		this.powerSource = Arrays.asList(powerSources);
		super.addAll(this.powerSource);
		
		if (null==systemCase) throw new RuntimeException("Must contain one system case.");
		this.systemCase = systemCase;
		super.add(this.systemCase);
		
		this.serverClass = serverClass;
		this.towerForm = towerForm;
	}
	
	public boolean isServerClass() {
		return serverClass;
	}
	
	public boolean isTowerForm() {
		return towerForm;
	}
	
	public Product getSystemCase() {
		return systemCase;
	}
	
	public Collection<Product> getPowerSources() {
		return powerSource;
	}
}
