package oose.class_diagram;

import java.util.ArrayList;

public class ComputerStore {
	
	public static void main(String[] args) {
		Product p = buildComputer();
		
		System.out.println(p.specs()); /* consider the call p.specs() a found message */
		
		addPlatform(p);
		System.out.println("Price: "+p.price()); /* consider the call p.price() another found message */
	}

	private static Product buildComputer() {
		ArrayList<Product> 
			inputList = new ArrayList<Product>(), 
			memoryList = new ArrayList<Product>(), 
			harddriveList = new ArrayList<Product>();

		Product 
			power = createNew("DreamOfFusion","Carbonite 999G",300),
			computerEnclosure = createNew("UltraCase 56XPDQ",30),

			hard = createNew("EasternAnalog UltraStore","Hard Drive",250),
			keyb = createNew("WiresAllInOne",30),
			mem1 = createNew("CorsaruDeLaDunare 9G",100)
		;
		power.addSpec("Output", "500W");
		
		inputList.add(keyb);
		memoryList.add(mem1);
		harddriveList.add(hard);
		
		ComputerSystem cs = new ComputerSystem("PimpedUP",memoryList,harddriveList,inputList);
		cs.setName("Drooling Gates");
		
		CaseAndPower poweredCase = new CaseAndPower(false,true,computerEnclosure,power);
		poweredCase.setName("CarboFusion Case");
		cs.setCaseAndPower(poweredCase);
		return cs;
	}
	
	private static void addPlatform(Product p) {
		ComputerSystem cs = (ComputerSystem)p;
		Platform platf=new Platform("Core1400",true, createNew("XNTEL board 15043",90), createNew("XNTEL core 15043",70));
		platf.setName("Core1400 MoboCPU Package");
		cs.setPlatform(platf);
	}
	

	private static Product addSpecification(Product hardware, String name, String kind) {
		hardware.setName(name);
		hardware.addSpec("Kind", kind);
		
		return hardware;
	}
	
	private static Product createNew(String name, String kind, float price) {
		Product hardware = new SingleProduct(price);
		return addSpecification(hardware, name, kind);
	} 

	private static Product createNew(String name, float price) {
		Product hardware = new SingleProduct(price);
		hardware.setName(name);
		return hardware;
	} 
}
